#include <stdio.h>
#include <stdlib.h>
#include "pthread.h"
#include "temporizadores.h"

int _tabla1[100],_tabla2[100];
int _contador;

pthread_mutex_t _mutex;

void* FuncionHilo2Mutex(void* param)
{
	int d1=1,d2=1;
	int ultCont;

	ultCont=_contador;
	while (1)
	{
		sleep(1);
		if (_contador> ultCont)
		{
			pthread_mutex_lock(&_mutex);
			d1=_tabla1[_contador-1];
			printf("Retardo d2...");
			sleep(5);
			printf("Fin retardo");
			d2=_tabla2[_contador-1];
			pthread_mutex_unlock(&_mutex);

			printf("d1 = %d / d2= %d\n",d1,d2);

			ultCont= _contador;
		}
		else
			printf(".");

		if (d1==0 && d2==0)
			break;
	}

	printf("Va a terminar Hilo2\n");
	sleep(1);
	printf("Terminado hilo 2\n");

	pthread_exit(NULL);

	return NULL;
}

TestMutex()
{
	pthread_t hilo2;
	int dato1,dato2;
	void* valor_dvto;

	pthread_mutex_init(&_mutex,NULL);

	pthread_create(&hilo2,NULL,FuncionHilo2Mutex,NULL);

	_contador=0;
	_tabla1[0]=_tabla2[0]=1;
	while (1)
	{
		printf("Dame datos: ");
		scanf("%d%d",&dato1,&dato2);

		pthread_mutex_lock(&_mutex);
		_tabla1[_contador]=dato1;
		_tabla2[_contador]=dato2;
		_contador++;
		pthread_mutex_unlock(&_mutex);
		if (dato1==0 && dato2==0)
			break;
		if (dato1==1)
			pthread_mutex_unlock(&_mutex);
	}

	printf("Esperando fin de hilo 2\n");
	pthread_join(hilo2,&valor_dvto);
	printf("Detectado fin de hilo 2\n");

	pthread_mutex_destroy(&_mutex);
	fflush(stdin);
	getchar();

	return 0;
}

