#include <stdio.h>
#include <stdlib.h>
#include "pthread.h"
#include "semaphore.h"
#include "temporizadores.h"

int _tabla1[100],_tabla2[100];
int _contador;

sem_t _semaforo;

void* FuncionHilo2Semaforo(void* param)
{
	int d1=1,d2=1;
	int ultCont;

	ultCont=_contador;
	while (1)
	{
		sleep(1);
		if (_contador> ultCont)
		{
			sem_wait(&_semaforo);
			d1=_tabla1[_contador-1];
			printf("Retardo d2...");
			sleep(5);
			printf("Fin retardo");
			d2=_tabla2[_contador-1];
			ultCont= _contador;
			sem_post(&_semaforo);

			printf("d1 = %d / d2= %d\n",d1,d2);

		}
		else
			printf(".");

		if (d1==0 && d2==0)
			break;
	}

	printf("Va a terminar Hilo2\n");
	sleep(1);
	printf("Terminado hilo 2\n");

	pthread_exit(NULL);

	return NULL;
}

TestSemaforos()
{
	pthread_t hilo2;
	int dato1,dato2;
	void* valor_dvto;

	sem_init(&_semaforo,0,1);

	pthread_create(&hilo2,NULL,FuncionHilo2Semaforo,NULL);

	_contador=0;
	_tabla1[0]=_tabla2[0]=1;
	while (1)
	{
		printf("Dame datos: ");
		scanf("%d%d",&dato1,&dato2);

		sem_wait(&_semaforo);
		_tabla1[_contador]=dato1;
		_tabla2[_contador]=dato2;
		_contador++;
		sem_post(&_semaforo);
		if (dato1==0 && dato2==0)
			break;
		if (dato1==1)
			sem_post(&_semaforo);
	}

	printf("Esperando fin de hilo 2\n");
	pthread_join(hilo2,&valor_dvto);
	printf("Detectado fin de hilo 2\n");

	sem_destroy(&_semaforo);
	fflush(stdin);
	getchar();

	return 0;
}

