// PROGRAMA DE EJEMPLO DE DIVERSOS MODOS DE SINCRONIZACION EN POSIX
// Programa principal. Se encarga de lanzar a los diferentes casos

#include <stdio.h>
#include <stdlib.h>


void TestExcepciones();
void TestSemaforos();
void TestMutex();
void TestMutexVbleCondicion();
void TestTemporizadores();
void TestMensajes2();

main()
{
	while (1)
	{
		printf("Probar:\n 1) Seales (excepciones)\n 2) Semforos\n 3) Mutex\n 4) Mutex + vble condicin\n 5) Temporizadores\n 6) Colas de Mensajes\n 0) Fin\n Seleccin: ");
		switch (fflush(stdin),getchar()-'0')
		{
		case 1:
			TestExcepciones();
			break;
		case 2:
			TestSemaforos();
			break;
		case 3:
			TestMutex();
			break;
		case 4:
			TestMutexVbleCondicion();
			break;
		case 5:
			TestTemporizadores();
			break;
		case 6:
			TestMensajes2();
			break;
		case 0:
			printf("Saliendo del programa. Pulse tecla");
			fflush(stdin);
			getchar();
			exit(1);
		}
	}
}