// EXCEPCIONES 


#include <stdio.h>
#include <stdlib.h>

#include <setjmp.h>
#include <float.h>

#include "pthread.h"
#include "senyales.h"
#include "temporizadores.h"


#include <windows.h>
#pragma comment(lib,"kernel32.lib")

volatile int _errFPE=0,_errMem=0;
jmp_buf _mark;

void SignalFn(int code)
{
	_errFPE=_errMem=0;
	if (code==SIGFPE)
	{
		_errFPE=1;
		_clear87();
		longjmp(_mark,5);
	}
	else if (code==SIGSEGV)
	{
		_errMem=1;
		longjmp(_mark,-5);
	}
}


TestExcepciones()
{
	float x=17.0, y=6.0,z;
	int jmpret;
	float *pt;

	signal(SIGFPE,SignalFn);
	signal(SIGSEGV,SignalFn);

    _control87( ~ _EM_ZERODIVIDE, _MCW_EM );

	jmpret = setjmp(_mark);
	if (jmpret<0)
	{
		printf("Error FPE = %3d   Error MEM = %3d\n",_errFPE,_errMem);
		fflush(stdin);
		printf("Fin de programa por error grave. Pulse RETURN");
		getchar();
		exit(0);
	}
	else if (jmpret>0)
	{
		printf("Error FPE = %3d   Error MEM = %3d\n",_errFPE,_errMem);
		fflush(stdin);
		printf("Sigue programa. Pulse RETURN");
		getchar();
	}

	while (y>0)
	{
		sleep(1);
		y-=1;
		z= x/y;
		printf("x= %5.1f   y= %5.1f    z=x/y= %5.1f\n",x,y,z);
	}


	sleep(1);
	pt=&x;
	*pt=15.0F;
	printf("pt= &x	*pt= %5.1f    Error MEM = %3d\n",*pt,_errMem);

	sleep(1);
	pt=&y;
	*pt=17.0F;
	printf("pt= &y  *pt= %5.1f    Error MEM = %3d\n",*pt,_errMem);


	sleep(1);
	pt+=200000;
	*pt=17.0F;
	printf("No se debe alcanzar esta lnea pt=&y+200000   *pt= %5.1f    Error MEM = %3d\n",*pt,_errMem);

	fflush(stdin);
	printf("Pulse RETURN");
	getchar();
}
