// Mensajes POSIX
#include <stdio.h>
#include <stdlib.h>

#include "pthread.h"
#include "mensajes.h"
#include "temporizadores.h"


void* FuncionHilo2Mensajes(void* param)
{
	int tabla1[100],tabla2[100];
	int contador;
	mqd_t cola_mensajes;

	unsigned msg_prio;
	int tabladatos[2];

	contador=0;
	cola_mensajes=mq_open("COLA PRUEBA",O_RDONLY);
	while (1)
	{
		mq_receive(cola_mensajes,(char*) tabladatos,2*sizeof(int),&msg_prio);

		tabla1[contador]=tabladatos[0];
		printf("Retardo d2...");
		sleep(5);
		printf("Fin retardo");
		tabla2[contador]=tabladatos[1];

		contador++;
		printf("d1 = %d / d2= %d\n",tabladatos[0],tabladatos[1]);

		if (tabladatos[0]==0 && tabladatos[1]==0)
			break;
	}

	printf("Va a terminar Hilo2\n");
	sleep(1);
	printf("Terminado hilo 2\n");

	pthread_exit(NULL);

	return NULL;
}

TestMensajes2()
{
	pthread_t hilo2;
	int datos[2];
	void* valor_dvto;

	mqd_t idqueue;
	struct mq_attr attr;

	attr.mq_curmsgs=0;
	attr.mq_flags=0;
	attr.mq_maxmsg=10;
	attr.mq_msgsize=2*sizeof(int);

	idqueue=mq_open("COLA PRUEBA",O_CREAT | O_WRONLY,(mode_t) 0,&attr);

	pthread_create(&hilo2,NULL,FuncionHilo2Mensajes,NULL);

	while (1)
	{
		printf("Dame datos: ");
		scanf("%d%d",&datos[0],&datos[1]);

		mq_send(idqueue,(char*) datos,2*sizeof(int),10);

		if (datos[0]==0 && datos[1]==0)
			break;
	}

	printf("Esperando fin de hilo 2\n");
	pthread_join(hilo2,&valor_dvto);
	printf("Detectado fin de hilo 2\n");


	mq_unlink("COLA PRUEBA");
	fflush(stdin);
	getchar();

	return 0;
}

